#ifndef TABLEGEN_TABLEGEN_HPP
#define TABLEGEN_TABLEGEN_HPP

#include "Settings.hpp"

#ifdef TABLEGEN_EXPOSE_XML
#include <pugixml.hpp>
#endif

#include <string>
#include <vector>

namespace Tablegen
{
    std::string GeneratePage(std::vector<CharacterInfo> characters,
                             const Settings& settings = Settings::Default());

    void GeneratePage(const std::string& path, std::vector<CharacterInfo> characters,
                      const Settings& settings = Settings::Default());

#   ifdef TABLEGEN_EXPOSE_XML
    void GenerateAsChild(pugi::xml_node& node, std::vector<CharacterInfo> characters,
                         const Settings& settings = Settings::Default());

    pugi::xml_document GenerateDocument(std::vector<CharacterInfo> characters, const Settings& settings = Settings::Default());
#   endif
}

#endif // TABLEGEN_TABLEGEN_HPP
